import '../adapter.dart';
import '../query.dart';

abstract class SQL extends Adapter {
  String getSQLCondition(Query query);
  String getSQLConditions(List<Query> queries, [String separator = 'AND']) {
    var conditions = <String>[];
    for (var query in queries) {
      if (query.method == Query.typeSelect) {
        continue;
      }

      if (query.isNested()) {
        conditions
            .add(getSQLConditions(query.values as List<Query>, query.method));
      } else {
        conditions.add(getSQLCondition(query));
      }
    }

    var tmp = conditions.join(' $separator ');
    return tmp.isEmpty ? '' : '($tmp)';
  }
}
